package com.hzya.frame.deletedata;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
//import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.deletedata.cancelsignature.ApproveinfoCancelSignature;
import com.hzya.frame.deletedata.cancelsignature.JsonRootBeanCancelSignature;
import com.hzya.frame.deletedata.cancelsignature.QueryinfoCancelSignature;
import com.hzya.frame.deletedata.dao.DeleteU8cDataUtilDao;
import com.hzya.frame.deletedata.entity.DeleteU8cDataUtilEntity;
//import com.hzya.frame.plugin.lets.dao.ISoSaleinvoiceDao;
//import com.hzya.frame.plugin.lets.entity.SoSaleinvoiceEntity;
//import com.hzya.frame.plugin.lets.u8cdto.ReusltStrDto;
import com.hzya.frame.deletedata.vo.*;
import com.hzya.frame.split.SplitListByCountUtil;
import com.hzya.frame.ttxofs.dto.ofssaleorderoutsearch.HeaderDetailsDto;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
//import org.junit.jupiter.api.Test;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.plugin.lets.util
 * @Project：kangarooDataCenterV3
 * @name：DeleteU8cDataUtil
 * @Date：2024/12/18 18:35
 * @Filename：DeleteU8cDataUtil
 */
@Component
public class DeleteU8cDataUtil {

    @Autowired
    private DeleteU8cDataUtilDao deleteU8cDataUtilDao;

    protected Logger logger = LogManager.getLogger(super.getClass());

    private static final Object LOCK_OBJECT = new Object();

    private static final Object LOCK_OBJECT2 = new Object();

    private static final Integer SPLIT_VAR = 1000;

    private static Integer MARK = 0;

    private static Integer MARK2 = 0;

    CountDownLatch latch = new CountDownLatch(2);

    @PostConstruct
    public void init() {
//        deleteTargetU8cData();
    }

    public void deleteTargetU8cData() {
        Thread thread000 = new Thread(new Runnable() {
            @Override
            public void run() {
//                Thread thread = new Thread(new Runnable() {
//                    @Override
//                    public void run() {
//                        synchronized (LOCK_OBJECT) {
//                            if (MARK == 0) {
//                                MARK = 1;
//                                //删除销售出库单
////                                cancelSignatureSoSaleReadExcel20250528V2();
//                                //反审核销售订单
////                                cancelSignatureSoSaleReadExcel2505282140V2();
//                            }
//                        }
//                        latch.countDown();
//                    }
//                }, "反审核销售订单 2025-05-30");
//                thread.start();
//
//                Thread thread2 = new Thread(new Runnable() {
//                    @Override
//                    public void run() {
//                        synchronized (LOCK_OBJECT2) {
//                            if (MARK2 == 0) {
//                                MARK2 = 1;
//                                //删除销售发票
////                                abandonmentReviewSoSaleinvoice2505282107();
//                            }
//                        }
//                        latch.countDown();
//                    }
//                }, "删除销售发票 2025-05-30");
//                thread2.start();

                try {
                    //等待两个线程都完成
//                    latch.await();
                    //在两个线程都完成后执行反审核销售订单方法
//                    cancelSignatureSoSaleReadExcel2505282140V2();
                    //修复销售订单部门字段错误问题
//                    repairSoSaleDepartment();
                    //销售订单审核
//                    salesOrderReviewV2();
                } catch (Exception e) {
                    e.printStackTrace();
//                    Thread.currentThread().interrupt();
//                    throw new RuntimeException("等待线程完成时中断", e);
                }
            }
        }, "U8C单据逻辑处理：销售订单审核");
        thread000.start();
    }

    /**
     * 销售订单取消签字
     */
    public void cancelSignatureSoSale() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            deleteSoSaleVo.setFstatus("2");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleByDelete(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    List<String> stringList = new ArrayList<>();
                    stringList.add(deleteU8cDataUtilEntity.getVreceiptcode());

                    JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();

                    QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
                    queryinfoCancelSignature.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfoCancelSignature.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfoCancelSignature.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfoCancelSignature.setCode(stringList);

                    ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
                    approveinfoCancelSignature.setApprovid("tbadmin");

                    jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
                    jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/unapprove", JSON.toJSONString(jsonRootBeanCancelSignature), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * 销售订单取消签字
     * 每1000条取消签字，需要236秒，平均0.2秒一条
     */
    public void cancelSignatureSoSaleV2() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            deleteSoSaleVo.setFstatus("2");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleByDelete(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        List<String> stringList = new ArrayList<>();
//                        stringList.add(deleteU8cDataUtilEntity.getVreceiptcode());
//                        JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();
//                        QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
//                        queryinfoCancelSignature.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfoCancelSignature.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfoCancelSignature.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                        queryinfoCancelSignature.setCode(stringList);
//                        ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
//                        approveinfoCancelSignature.setApprovid("tbadmin");
//                        jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
//                        jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);


                        Map<String, Object> stringObjectMap = new HashMap<>();
                        stringObjectMap.put("approvid", "tbadmin");

                        Map<String, Object> stringObjectMap2 = new HashMap<>();
                        stringObjectMap2.put("date_begin", split[0]);
                        stringObjectMap2.put("date_end", split[0]);
                        stringObjectMap2.put("corp", split[1]);
                        stringObjectMap2.put("code", vreceiptcodeList);

                        Map<String, Object> stringObjectMap3 = new HashMap<>();
                        stringObjectMap3.put("approveinfo", stringObjectMap);
                        stringObjectMap3.put("queryinfo", stringObjectMap2);

                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/unapprove", JSON.toJSONString(stringObjectMap3), vreceiptcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售订单
     */
//    public void deleteSoSale() {
//        try {
//            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
//            deleteSoSaleVo.setDataSourceCode("lets_u8c");
//            deleteSoSaleVo.setFstatus(1L);
//            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleByDelete(deleteSoSaleVo);
//            logger.info("条数：{}", soSaleinvoiceEntities.size());
//            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
//                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
//                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);
//
//                    Deleteinfo deleteinfo = new Deleteinfo();
//                    deleteinfo.setCoperator("tbadmin");
//
//                    Queryinfo queryinfo = new Queryinfo();
//                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                    queryinfo.setCode(deleteU8cDataUtilEntity.getVreceiptcode());
//
//                    JsonRootBean jsonRootBean = new JsonRootBean();
//                    jsonRootBean.setDeleteinfo(deleteinfo);
//                    jsonRootBean.setQueryinfo(queryinfo);
//                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/delete", JSON.toJSONString(jsonRootBean));
//                }
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

    /**
     * 删除销售出库单
     */
    public void deleteIcGeneralH() {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByDelete(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Deleteinfo deleteinfo = new Deleteinfo();
                    deleteinfo.setCoperator("tbadmin");

                    Queryinfo queryinfo = new Queryinfo();
                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                    queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());

                    JsonRootBean jsonRootBean = new JsonRootBean();
                    jsonRootBean.setDeleteInfo(deleteinfo);
                    jsonRootBean.setQueryInfo(queryinfo);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/delete", JSON.toJSONString(jsonRootBean), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售出库单
     */
    public void deleteIcGeneralHV2() {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByDelete(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vbillcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        Deleteinfo deleteinfo = new Deleteinfo();
//                        deleteinfo.setCoperator("tbadmin");
//                        Queryinfo queryinfo = new Queryinfo();
//                        queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                        queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());
//                        JsonRootBean jsonRootBean = new JsonRootBean();
//                        jsonRootBean.setDeleteInfo(deleteinfo);
//                        jsonRootBean.setQueryInfo(queryinfo);

                        Map<String, Object> objectMap = new HashMap<>();
                        objectMap.put("coperator", "tbadmin");

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("billcode", vbillcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("deleteInfo", objectMap);
                        objectMap3.put("queryInfo", objectMap2);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/delete", JSON.toJSONString(objectMap3), vbillcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 销售出库单取消签字
     */
    public void cancelSignatureIcGeneralH(String cbiztype) {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            deleteIcGeneralHVo.setCbiztype(cbiztype);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignature(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Deleteinfo deleteinfo = new Deleteinfo();
                    deleteinfo.setCoperator("tbadmin");

                    Queryinfo queryinfo = new Queryinfo();
                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                    queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());

                    JsonRootBean jsonRootBean = new JsonRootBean();
                    jsonRootBean.setUnsignInfo(deleteinfo);
                    jsonRootBean.setQueryInfo(queryinfo);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(jsonRootBean), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 销售出库单取消签字 V2
     */
    public void cancelSignatureIcGeneralHV2(String cbiztype) {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            deleteIcGeneralHVo.setCbiztype(cbiztype);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignature(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);

                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vbillcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        Deleteinfo deleteinfo = new Deleteinfo();
//                        deleteinfo.setCoperator("tbadmin");
//                        Queryinfo queryinfo = new Queryinfo();
//                        queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                        queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());
//                        JsonRootBean jsonRootBean = new JsonRootBean();
//                        jsonRootBean.setUnsignInfo(deleteinfo);
//                        jsonRootBean.setQueryInfo(queryinfo);

                        Map<String, Object> objectMap1 = new HashMap<>();
                        objectMap1.put("coperator", "tbadmin");

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("billcode", vbillcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("unsignInfo", objectMap1);
                        objectMap3.put("queryInfo", objectMap2);

//                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                        sendU8C("http://192.168.10.118:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * 销售出库单签字
     */
    public void saleOutSign(String cbiztype) {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            deleteIcGeneralHVo.setCbiztype(cbiztype);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHBySign(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);

                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vbillcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

                        Map<String, Object> objectMap1 = new HashMap<>();
                        objectMap1.put("coperator", "tbadmin");
                        objectMap1.put("date_sign", split[0]);

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("billcode", vbillcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("signInfo", objectMap1);
                        objectMap3.put("queryInfo", objectMap2);

//                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/sign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                        sendU8C("http://192.168.10.118:8088/u8cloud/api/ic/saleout/sign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售发票
     */
    public void deleteSoSaleinvoice() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByDelete(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Deleteinfo deleteinfo = new Deleteinfo();
                    deleteinfo.setCoperator("tbadmin");

                    Queryinfo queryinfo = new Queryinfo();
                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                    queryinfo.setCode(deleteU8cDataUtilEntity.getVreceiptcode());

                    JsonRootBean jsonRootBean = new JsonRootBean();
                    jsonRootBean.setDeleteinfo(deleteinfo);
                    jsonRootBean.setQueryinfo(queryinfo);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/delete", JSON.toJSONString(jsonRootBean), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售发票V2,速度提升版
     */
    public void deleteSoSaleinvoiceV2() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByDelete(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);
                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        Deleteinfo deleteinfo = new Deleteinfo();
//                        deleteinfo.setCoperator("tbadmin");

//                        Queryinfo queryinfo = new Queryinfo();
//                        queryinfo.setCorp(split[1]);
//                        queryinfo.setDate_begin(split[0]);
//                        queryinfo.setDate_end(split[0]);
//                        queryinfo.setCode(vreceiptcodeList);

//                        JsonRootBean jsonRootBean = new JsonRootBean();
//                        jsonRootBean.setDeleteinfo(deleteinfo);
//                        jsonRootBean.setQueryinfo(queryinfo);

                        Map<String, Object> objectMap = new HashMap<>();
                        objectMap.put("coperator", "tbadmin");

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("code", vreceiptcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("deleteinfo", objectMap);
                        objectMap3.put("queryinfo", objectMap2);

                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/delete", JSON.toJSONString(objectMap3), vreceiptcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private Object lockObject = new Object();

    /**
     * 2024年8月8日 10:54:48
     * 推送U8C销售订单方法
     *
     * @author liuyang
     */
    public void sendU8C(String url, String param, Integer number) throws Exception {
        synchronized (lockObject) {
            logger.info("入参：" + param);
            long l = System.currentTimeMillis();
            String result = HttpRequest.post(url).header("usercode", "admin1").header("password", "f7fcde654e968541cc803c4b08c30abb").header("system", "lz1").header("trantype", "code").body(param)//表单内容
//                .timeout(900000000)//超时，毫秒，超时时间调整为1个小时
                    .timeout(3600000).execute().body();
            long l1 = System.currentTimeMillis();
            long timeConsuming = l1 - l;
            logger.info("\n回参：" + result + " \n执行耗时：" + timeConsuming + "\n条数：" + number + " 每单耗时：" + (timeConsuming / 1000 / number));
//        JSONObject jsonObject = JSON.parseObject(result);
//        result = String.valueOf(jsonObject.get("attribute"));
//        System.out.println(result);
        }
    }

    /**
     * 弃审应收单
     *
     * @author liuyang
     */
    public void abandoningReviewAccReceDoc() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.abandonmentAccountsReceivableDoc(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                    String dateString = sdf.format(new Date());

                    Map<String, String> stringStringMap = new HashMap<>();
                    stringStringMap.put("djbh", deleteU8cDataUtilEntity.getDjbh());//单据编码
                    stringStringMap.put("dwbm", deleteU8cDataUtilEntity.getUnitcode());//公司编码
                    stringStringMap.put("operatorid", "18846145294");//操作人编码
                    stringStringMap.put("operatedate", dateString);//操作日期

                    List<Map<String, String>> mapList = new ArrayList<>();
                    mapList.add(stringStringMap);

                    Map<String, List<Map<String, String>>> stringStringMap2 = new HashMap<>();
                    stringStringMap2.put("bills", mapList);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/arap/ys/unaudit", JSON.toJSONString(stringStringMap2), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除自由态的应收单
     *
     * @author liuyang
     */
    public void deleteReviewAccReceDoc() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.abandonmentAccountsReceivableDocFreeState(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Map<String, String> stringStringMap = new HashMap<>();
                    stringStringMap.put("coperator", "tbadmin");

                    Map<String, String> stringStringMap2 = new HashMap<>();
                    stringStringMap2.put("dwbm", deleteU8cDataUtilEntity.getUnitcode());
                    stringStringMap2.put("djbh_from", deleteU8cDataUtilEntity.getDjbh());
                    stringStringMap2.put("djbh_to", deleteU8cDataUtilEntity.getDjbh());

                    Map<String, Map<String, String>> stringStringMap3 = new HashMap<>();
                    stringStringMap3.put("deleteinfo", stringStringMap);
                    stringStringMap3.put("queryinfo", stringStringMap2);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/arap/ys/delete", JSON.toJSONString(stringStringMap3), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 弃审销售发票
     */
    public void abandonmentReviewSoSaleinvoice() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByCancelApproval(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    try {
                        Map<String, String> stringStringMap = new HashMap<>();
                        stringStringMap.put("approvid", "tbadmin");

                        Map<String, String> stringStringMap2 = new HashMap<>();
                        stringStringMap2.put("corp", deleteU8cDataUtilEntity.getUnitcode());
                        stringStringMap2.put("code", deleteU8cDataUtilEntity.getVreceiptcode());
                        stringStringMap2.put("date_begin", deleteU8cDataUtilEntity.getDbilldate());
                        stringStringMap2.put("date_end", deleteU8cDataUtilEntity.getDbilldate());

                        Map<String, Map<String, String>> stringStringMap3 = new HashMap<>();
                        stringStringMap3.put("approveinfo", stringStringMap);
                        stringStringMap3.put("queryinfo", stringStringMap2);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/unapprove", JSON.toJSONString(stringStringMap3), 1);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            // 关闭线程池
//            executor.shutdown();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 2025年2月11日 14:54:30
     * 弃审销售发票，速度提升版
     * 弃审367需要515秒，每条1.4秒，单条弃审大概需要1.8秒
     * 286 -> 397 1.3秒
     * 速度有一定的提升
     *
     * @author liuyang
     */
    public void abandonmentReviewSoSaleinvoiceV2() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByCancelApproval(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    try {
                        for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                            String key = entry.getKey();
                            List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                            List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                            String[] split = key.split("@@@@");

                            Map<String, Object> stringStringMap = new HashMap<>();
                            stringStringMap.put("approvid", "tbadmin");

                            Map<String, Object> stringStringMap2 = new HashMap<>();
                            stringStringMap2.put("corp", split[1]);
                            stringStringMap2.put("code", vreceiptcodeList);
                            stringStringMap2.put("date_begin", split[0]);
                            stringStringMap2.put("date_end", split[0]);

                            Map<String, Map<String, Object>> stringStringMap3 = new HashMap<>();
                            stringStringMap3.put("approveinfo", stringStringMap);
                            stringStringMap3.put("queryinfo", stringStringMap2);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/unapprove", JSON.toJSONString(stringStringMap3), vreceiptcodeList.size());
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            // 关闭线程池
//            executor.shutdown();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 把相同单据日期+公司的发票汇总在一起
     *
     * @author liuyang
     */
    public static Map<String, List<DeleteU8cDataUtilEntity>> groupByDbilldate(List<DeleteU8cDataUtilEntity> entities) {
        Map<String, List<DeleteU8cDataUtilEntity>> resultMap = new HashMap<>();
        for (DeleteU8cDataUtilEntity entity : entities) {
            String dbilldate = entity.getDbilldate();
            String unitcode = entity.getUnitcode();
            // 如果 map 中不包含该日期，则创建一个新的列表
            resultMap.computeIfAbsent(dbilldate + "@@@@" + unitcode, k -> new ArrayList<>()).add(entity);
        }
        return resultMap;
    }

    /**
     * 把相同单据日期+公司的发票汇总在一起
     *
     * @author liuyang
     */
//    public static Map<String, List<DeleteU8cDataUtilEntity>> groupByDbilldateV2(List<DeleteU8cDataUtilEntity> entities) {
//        Map<String, List<DeleteU8cDataUtilEntity>> resultMap = new HashMap<>();
//        for (DeleteU8cDataUtilEntity entity : entities) {
//            String dbilldate = entity.getDbilldate();
//            String unitcode = entity.getUnitcode();
//            // 如果 map 中不包含该日期，则创建一个新的列表
//            resultMap.computeIfAbsent(dbilldate + "@@@@" + unitcode, k -> new ArrayList<>()).add(entity);
//        }
//        return resultMap;
//    }

    // 定义最大线程数
//    private static final int MAX_THREADS = 100;

    // 创建一个固定大小的线程池
//    ExecutorService executor = Executors.newFixedThreadPool(MAX_THREADS);


    /**
     * 销售订单取消签字
     */
    public void cancelSignatureSoSaleReadExcel() {
        try {
            FileInputStream file = new FileInputStream(new File("/Users/liuyang/Desktop/U8C-需要删除的单据-带主键.xlsx"));
            Workbook workbook = new XSSFWorkbook(file);

            List<String[]> data = new ArrayList<>();

            for (int i = 0; i < 5; i++) {
                Sheet sheet = workbook.getSheetAt(i);
                for (Row row : sheet) {
                    String bValue = "";
                    String cValue = "";
                    String dValue = "";
                    if (row.getCell(1) != null) {
                        bValue = row.getCell(1).getStringCellValue();
                    }
                    if (row.getCell(2) != null) {
                        cValue = row.getCell(2).getStringCellValue();
                    }
                    if (row.getCell(3) != null) {
                        dValue = row.getCell(3).getStringCellValue();
                    }
                    data.add(new String[]{bValue, cValue, dValue});
                }
            }

            // Print the B and C column data
            long saleoutNum = 0;
            for (String[] rowData : data) {
//                System.out.println("B: " + rowData[0] + ", C: " + rowData[1]);

                //**销售出库单**
                try {
                    //查找销售订单对应的销售出库单
                    DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
                    deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
                    deleteIcGeneralHVo.setCfirstbillhid(rowData[2]);
                    List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignatureV2(deleteIcGeneralHVo);
//                    logger.info("条数：{}", soSaleinvoiceEntities.size());
                    if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                        for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                            DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                            //销售出库单取消签字
                            Deleteinfo deleteinfo = new Deleteinfo();
                            deleteinfo.setCoperator("tbadmin");

                            Queryinfo queryinfo = new Queryinfo();
                            queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                            queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                            queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                            queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());

                            JsonRootBean jsonRootBean = new JsonRootBean();
                            jsonRootBean.setUnsignInfo(deleteinfo);
                            jsonRootBean.setQueryInfo(queryinfo);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(jsonRootBean), 1);

                            //销售出库单删除
                            Deleteinfo deleteinfo2 = new Deleteinfo();
                            deleteinfo2.setCoperator("tbadmin");

                            Queryinfo queryinfo2 = new Queryinfo();
                            queryinfo2.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                            queryinfo2.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                            queryinfo2.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                            queryinfo2.setBillcode(deleteU8cDataUtilEntity.getVbillcode());

                            JsonRootBean jsonRootBean2 = new JsonRootBean();
                            jsonRootBean2.setDeleteInfo(deleteinfo2);
                            jsonRootBean2.setQueryInfo(queryinfo2);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/delete", JSON.toJSONString(jsonRootBean2), 1);

                            saleoutNum++;
                            System.out.println("处理的销售出库单数量：" + saleoutNum);
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }

                //处理销售订单
                try {
                    //销售订单取消审核
                    List<String> stringList = new ArrayList<>();
                    stringList.add(rowData[1]);

                    JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();

                    QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
                    queryinfoCancelSignature.setDate_begin("2025-04-28");
                    queryinfoCancelSignature.setDate_end("2025-04-30");
                    queryinfoCancelSignature.setCorp(rowData[0]);
                    queryinfoCancelSignature.setCode(stringList);

                    ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
                    approveinfoCancelSignature.setApprovid("tbadmin");

                    jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
                    jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/unapprove", JSON.toJSONString(jsonRootBeanCancelSignature), 1);

                    //销售订单删除
                    Deleteinfo deleteinfo = new Deleteinfo();
                    deleteinfo.setCoperator("tbadmin");

                    Queryinfo queryinfo = new Queryinfo();
                    queryinfo.setCorp(rowData[0]);
                    queryinfo.setDate_begin("2025-04-28");
                    queryinfo.setDate_end("2025-04-30");
//                    queryinfo.setCode(rowData[1]);

                    JsonRootBean jsonRootBean = new JsonRootBean();
                    jsonRootBean.setDeleteinfo(deleteinfo);
                    jsonRootBean.setQueryinfo(queryinfo);
//                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/delete", JSON.toJSONString(jsonRootBean), 1);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            workbook.close();
            file.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * 销售出库单、销售订单取消签字+删除
     */
    public void cancelSignatureSoSaleReadExcelV2() {
        try {
//            FileInputStream file = new FileInputStream(new File("D:\\server\\软件包\\U8C-需要删除的单据-带主键.xlsx"));
            FileInputStream file = new FileInputStream(new File("/Users/liuyang/Desktop/U8C-需要删除的单据-带主键.xlsx"));
            Workbook workbook = new XSSFWorkbook(file);

            List<String[]> data = new ArrayList<>();
            for (int i = 0; i < 5; i++) {
                Sheet sheet = workbook.getSheetAt(i);
                for (Row row : sheet) {
                    String bValue = "";
                    String cValue = "";
                    String dValue = "";
                    if (row.getCell(1) != null) {
                        bValue = row.getCell(1).getStringCellValue();
                    }
                    if (row.getCell(2) != null) {
                        cValue = row.getCell(2).getStringCellValue();
                    }
                    if (row.getCell(3) != null) {
                        dValue = row.getCell(3).getStringCellValue();
                    }
                    data.add(new String[]{bValue, cValue, dValue});
                }
            }

            //按100行拆分
            List<List<String[]>> lists = SplitListByCountUtil.splitListByCount(data, 100);
            for (int i = 0; i < lists.size(); i++) {
                List<String[]> strings = lists.get(i);
                //处理销售出库单
                String result = strings.stream().filter(arr -> arr.length > 2)        // 确保有第三个元素（索引2）
                        .map(arr -> arr[2]).filter(Objects::nonNull).map(s -> "'" + s + "'")             // 添加单引号包装
                        .collect(Collectors.joining(","));
                //根据销售订单主键，查询对应的销售出库单
                DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
                deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
                deleteIcGeneralHVo.setCfirstbillhids(result);
                List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignatureV2(deleteIcGeneralHVo);
                Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldatev2(soSaleinvoiceEntities);

                if (stringListMap.size() > 0) {
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

                        //批量销售出库单取消签字
                        Deleteinfo deleteinfo = new Deleteinfo();
                        deleteinfo.setCoperator("tbadmin");

                        Queryinfo queryinfo = new Queryinfo();
                        queryinfo.setCorp(split[1]);
                        queryinfo.setDate_begin(split[0]);
                        queryinfo.setDate_end(split[0]);
                        queryinfo.setBillcode(vreceiptcodeList);

                        JsonRootBean jsonRootBean = new JsonRootBean();
                        jsonRootBean.setUnsignInfo(deleteinfo);
                        jsonRootBean.setQueryInfo(queryinfo);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(jsonRootBean), vreceiptcodeList.size());

                        //批量销售出库单删除
                        Deleteinfo deleteinfo2 = new Deleteinfo();
                        deleteinfo2.setCoperator("tbadmin");

                        Queryinfo queryinfo2 = new Queryinfo();
                        queryinfo2.setCorp(split[1]);
                        queryinfo2.setDate_begin(split[0]);
                        queryinfo2.setDate_end(split[0]);
                        queryinfo2.setBillcode(vreceiptcodeList);

                        JsonRootBean jsonRootBean2 = new JsonRootBean();
                        jsonRootBean2.setDeleteInfo(deleteinfo2);
                        jsonRootBean2.setQueryInfo(queryinfo2);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/delete", JSON.toJSONString(jsonRootBean2), vreceiptcodeList.size());
                    }
                }

                //处理销售订单
                DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
                deleteSoSaleVo.setDataSourceCode("lets_u8c");
                deleteSoSaleVo.setCsaleids(result);
                List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = deleteU8cDataUtilDao.querySoSaleByDeletev2(deleteSoSaleVo);
                Map<String, List<DeleteU8cDataUtilEntity>> deleteU8cDataUtilEntitiesMap = groupByDbilldatev2(deleteU8cDataUtilEntities);

                if (deleteU8cDataUtilEntitiesMap.size() > 0) {
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : deleteU8cDataUtilEntitiesMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

                        //批量销售订单取消审核
                        JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();

                        QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
                        queryinfoCancelSignature.setDate_begin(split[0]);
                        queryinfoCancelSignature.setDate_end(split[0]);
                        queryinfoCancelSignature.setCorp(split[1]);
                        queryinfoCancelSignature.setCode(vreceiptcodeList);

                        ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
                        approveinfoCancelSignature.setApprovid("tbadmin");

                        jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
                        jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/unapprove", JSON.toJSONString(jsonRootBeanCancelSignature), vreceiptcodeList.size());

                        //批量销售订单删除
                        Deleteinfo deleteinfo = new Deleteinfo();
                        deleteinfo.setCoperator("tbadmin");

                        Queryinfo queryinfo = new Queryinfo();
                        queryinfo.setCorp(split[1]);
                        queryinfo.setDate_begin(split[0]);
                        queryinfo.setDate_end(split[0]);
                        queryinfo.setCode(vreceiptcodeList);

                        JsonRootBean jsonRootBean = new JsonRootBean();
                        jsonRootBean.setDeleteinfo(deleteinfo);
                        jsonRootBean.setQueryinfo(queryinfo);
//                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/delete", JSON.toJSONString(jsonRootBean), vreceiptcodeList.size());
                    }
                }
            }
            workbook.close();
            file.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

//        try {
//            //每10秒重新删除一次
//            Thread.sleep(10000);
//            cancelSignatureSoSaleReadExcelV2();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    }

    public Map<String, List<DeleteU8cDataUtilEntity>> groupByDbilldatev2(List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities) {
        Map<String, List<DeleteU8cDataUtilEntity>> resultMap = new HashMap<>();
        for (DeleteU8cDataUtilEntity entity : soSaleinvoiceEntities) {
            String dbilldate = entity.getDbilldate();
            String unitcode = entity.getUnitcode();
            // 如果 map 中不包含该日期，则创建一个新的列表
            resultMap.computeIfAbsent(dbilldate + "@@@@" + unitcode, k -> new ArrayList<>()).add(entity);
        }
        return resultMap;
    }


    /**
     * 销售出库单取消签证并删除
     */
    public void cancelSignatureSoSaleReadExcel20250528V2() {
        try {
            //确定销售订单范围、19648
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();

            //按100行拆分
            List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 100);
            if (lists.size() > 0) {
                for (int i = 0; i < lists.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
                    //逗号拼接
                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));

                    //根据销售订单主键，查询对应的销售出库单
                    DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
                    deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
                    deleteIcGeneralHVo.setCfirstbillhids(concatenatedIds);
                    deleteIcGeneralHVo.setFbillflag("3");//签字状态
                    List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignatureV2(deleteIcGeneralHVo);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldatev2(soSaleinvoiceEntities);

                    if (stringListMap.size() > 0) {
                        for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                            String key = entry.getKey();
                            List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                            List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                            String[] split = key.split("@@@@");

                            //批量销售出库单取消签字
                            Deleteinfo deleteinfo = new Deleteinfo();
                            deleteinfo.setCoperator("tbadmin");

                            Queryinfo queryinfo = new Queryinfo();
                            queryinfo.setCorp(split[1]);
                            queryinfo.setDate_begin(split[0]);
                            queryinfo.setDate_end(split[0]);
                            queryinfo.setBillcode(vreceiptcodeList);

                            JsonRootBean jsonRootBean = new JsonRootBean();
                            jsonRootBean.setUnsignInfo(deleteinfo);
                            jsonRootBean.setQueryInfo(queryinfo);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(jsonRootBean), vreceiptcodeList.size());
                        }
                    }

                    //根据销售订单主键，查询对应的销售出库单
                    DeleteIcGeneralHVo deleteIcGeneralHVo2 = new DeleteIcGeneralHVo();
                    deleteIcGeneralHVo2.setDataSourceCode("lets_u8c");
                    deleteIcGeneralHVo2.setCfirstbillhids(concatenatedIds);
                    deleteIcGeneralHVo2.setFbillflag("2");//自由状态
                    List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities2 = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignatureV2(deleteIcGeneralHVo2);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap2 = groupByDbilldatev2(soSaleinvoiceEntities2);
                    if (stringListMap2.size() > 0) {
                        for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap2.entrySet()) {
                            String key = entry.getKey();
                            List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                            List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                            String[] split = key.split("@@@@");

                            //批量销售出库单删除
                            Deleteinfo deleteinfo2 = new Deleteinfo();
                            deleteinfo2.setCoperator("tbadmin");

                            Queryinfo queryinfo2 = new Queryinfo();
                            queryinfo2.setCorp(split[1]);
                            queryinfo2.setDate_begin(split[0]);
                            queryinfo2.setDate_end(split[0]);
                            queryinfo2.setBillcode(vreceiptcodeList);

                            JsonRootBean jsonRootBean2 = new JsonRootBean();
                            jsonRootBean2.setDeleteInfo(deleteinfo2);
                            jsonRootBean2.setQueryInfo(queryinfo2);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/delete", JSON.toJSONString(jsonRootBean2), vreceiptcodeList.size());
                        }
                    }
                }
            }

            //验证是否还存在需要取消签字并删除的销售出库单
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntitieAll = new ArrayList<>();
            List<List<DeleteU8cDataUtilEntity>> lists2 = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 999);
            for (int i = 0; i < lists2.size(); i++) {
                List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists2.get(i);
                String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));
                DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
                deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
                deleteIcGeneralHVo.setCfirstbillhids(concatenatedIds);
                List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignatureV2(deleteIcGeneralHVo);
                soSaleinvoiceEntitieAll.addAll(soSaleinvoiceEntities);
            }
            if (soSaleinvoiceEntitieAll.size() > 0) {
                Thread.sleep(10000);
                cancelSignatureSoSaleReadExcel20250528V2();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 弃审销售发票，并删除销售发票
     */
    public void abandonmentReviewSoSaleinvoice2505282107() {
        try {
            //确定销售订单范围、19648
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
            List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 500);
            if (lists.size() > 0) {
                for (int i = 0; i < lists.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));
                    //取消审核销售发票
                    DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
                    soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
                    soSaleinvoiceEntity.setCsaleid(concatenatedIds);
                    soSaleinvoiceEntity.setFstatus("2");//审批状态
                    List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByCancelApprovalV2(soSaleinvoiceEntity);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(soSaleinvoiceEntities);
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

                        Map<String, Object> stringStringMap = new HashMap<>();
                        stringStringMap.put("approvid", "tbadmin");

                        Map<String, Object> stringStringMap2 = new HashMap<>();
                        stringStringMap2.put("corp", split[1]);
                        stringStringMap2.put("code", vreceiptcodeList);
                        stringStringMap2.put("date_begin", split[0]);
                        stringStringMap2.put("date_end", split[0]);

                        Map<String, Map<String, Object>> stringStringMap3 = new HashMap<>();
                        stringStringMap3.put("approveinfo", stringStringMap);
                        stringStringMap3.put("queryinfo", stringStringMap2);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/unapprove", JSON.toJSONString(stringStringMap3), vreceiptcodeList.size());
                    }

                    //删除销售发票
                    DeleteU8cDataUtilEntity soSaleinvoiceEntity2 = new DeleteU8cDataUtilEntity();
                    soSaleinvoiceEntity2.setDataSourceCode("lets_u8c");
                    soSaleinvoiceEntity2.setFstatus("1");//自由状态
                    soSaleinvoiceEntity2.setCsaleid(concatenatedIds);
                    List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities2 = deleteU8cDataUtilDao.querySoSaleinvoiceByCancelApprovalV2(soSaleinvoiceEntity2);
                    logger.info("条数：{}", soSaleinvoiceEntities2.size());
                    if (soSaleinvoiceEntities2 != null && soSaleinvoiceEntities2.size() > 0) {
                        List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities2, 100);
                        for (int j = 0; j < splitListByCount.size(); j++) {
                            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = splitListByCount.get(j);
                            Map<String, List<DeleteU8cDataUtilEntity>> stringListMap2 = groupByDbilldate(deleteU8cDataUtilEntities2);
                            for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap2.entrySet()) {
                                String key = entry.getKey();
                                List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                                List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                                String[] split = key.split("@@@@");

                                Map<String, Object> objectMap = new HashMap<>();
                                objectMap.put("coperator", "tbadmin");

                                Map<String, Object> objectMap2 = new HashMap<>();
                                objectMap2.put("corp", split[1]);
                                objectMap2.put("date_begin", split[0]);
                                objectMap2.put("date_end", split[0]);
                                objectMap2.put("code", vreceiptcodeList);

                                Map<String, Object> objectMap3 = new HashMap<>();
                                objectMap3.put("deleteinfo", objectMap);
                                objectMap3.put("queryinfo", objectMap2);

                                sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/delete", JSON.toJSONString(objectMap3), vreceiptcodeList.size());
                            }
                        }
                    }
                }
            }

            //判断是否还存在需要删除的发票
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities2All = new ArrayList<>();
//            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
            List<List<DeleteU8cDataUtilEntity>> lists2 = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 999);
            for (int i = 0; i < lists2.size(); i++) {
                List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists2.get(i);
                String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));

                DeleteU8cDataUtilEntity soSaleinvoiceEntity2 = new DeleteU8cDataUtilEntity();
                soSaleinvoiceEntity2.setDataSourceCode("lets_u8c");
                soSaleinvoiceEntity2.setCsaleid(concatenatedIds);
                List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities2 = deleteU8cDataUtilDao.querySoSaleinvoiceByCancelApprovalV2(soSaleinvoiceEntity2);
                soSaleinvoiceEntities2All.addAll(soSaleinvoiceEntities2);
            }
            if (soSaleinvoiceEntities2All.size() > 0) {
                Thread.sleep(10000);
                abandonmentReviewSoSaleinvoice2505282107();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 销售订单取消签字
     */
    public void cancelSignatureSoSaleReadExcel2505282140V2() {
        try {
            //确定销售订单范围、19648
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
            if (deleteU8cDataUtilEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 500);
                for (int i = 0; i < lists.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));
                    //销售订单取消审核
                    DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
                    deleteSoSaleVo.setDataSourceCode("lets_u8c");
                    deleteSoSaleVo.setCsaleids(concatenatedIds);
                    deleteSoSaleVo.setFstatus("2,6");
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = deleteU8cDataUtilDao.querySoSaleByDeletev2(deleteSoSaleVo);
                    Map<String, List<DeleteU8cDataUtilEntity>> deleteU8cDataUtilEntitiesMap = groupByDbilldatev2(deleteU8cDataUtilEntities2);
                    if (deleteU8cDataUtilEntitiesMap.size() > 0) {
                        for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : deleteU8cDataUtilEntitiesMap.entrySet()) {
                            String key = entry.getKey();
                            List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                            List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                            String[] split = key.split("@@@@");

                            //批量销售订单取消审核
                            JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();

                            QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
                            queryinfoCancelSignature.setDate_begin(split[0]);
                            queryinfoCancelSignature.setDate_end(split[0]);
                            queryinfoCancelSignature.setCorp(split[1]);
                            queryinfoCancelSignature.setCode(vreceiptcodeList);

                            ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
                            approveinfoCancelSignature.setApprovid("tbadmin");

                            jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
                            jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/unapprove", JSON.toJSONString(jsonRootBeanCancelSignature), vreceiptcodeList.size());
                        }
                    }
                }
            }

            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities22All = new ArrayList<>();
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
            if (deleteU8cDataUtilEntities2 != null) {
                List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 999);
                for (int i = 0; i < lists.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));

                    DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
                    deleteSoSaleVo.setDataSourceCode("lets_u8c");
                    deleteSoSaleVo.setCsaleids(concatenatedIds);
                    deleteSoSaleVo.setFstatus("2,6");
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities22 = deleteU8cDataUtilDao.querySoSaleByDeletev2(deleteSoSaleVo);
                    deleteU8cDataUtilEntities22All.addAll(deleteU8cDataUtilEntities22);
                }
            }
            if (deleteU8cDataUtilEntities22All.size() > 0) {
                Thread.sleep(10000);
                cancelSignatureSoSaleReadExcel2505282140V2();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 修复销售订单部门字段错误问题
     */
    public void repairSoSaleDepartment() {
        try {
            //确定销售订单范围、19648
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
            if (deleteU8cDataUtilEntities != null && deleteU8cDataUtilEntities.size() > 0) {
                for (DeleteU8cDataUtilEntity deleteU8cDataUtilEntity : deleteU8cDataUtilEntities) {
                    //找到正确的部门主键
                    if (deleteU8cDataUtilEntity.getCdeptid() == null) {
                        throw new Exception("deleteU8cDataUtilEntity.getCdeptid() == null");
                    }
                    if (deleteU8cDataUtilEntity.getPk_corp() == null) {
                        throw new Exception("deleteU8cDataUtilEntity.getPk_corp() == null");
                    }
                    QueryCorrectDeptIdVo queryCorrectDeptIdVo = new QueryCorrectDeptIdVo();
                    queryCorrectDeptIdVo.setPk_deptdoc(deleteU8cDataUtilEntity.getCdeptid());
                    queryCorrectDeptIdVo.setPk_corp(deleteU8cDataUtilEntity.getPk_corp());
                    List<QueryCorrectDeptIdVo> queryCorrectDeptIdVos = deleteU8cDataUtilDao.queryCorrectDeptId(queryCorrectDeptIdVo);
                    if (queryCorrectDeptIdVos == null || queryCorrectDeptIdVos.size() != 1) {
                        throw new Exception("queryCorrectDeptIdVos.size() != 1");
                    }
                    QueryCorrectDeptIdVo queryCorrectDeptIdVo1 = queryCorrectDeptIdVos.get(0);
                    //发起销售订单表头部门修改
                    UpdateSoSaleCdeptId updateSoSaleCdeptId = new UpdateSoSaleCdeptId();
                    updateSoSaleCdeptId.setCdeptid(queryCorrectDeptIdVo1.getNewdeptpk());//部门id
                    updateSoSaleCdeptId.setCsaleid(deleteU8cDataUtilEntity.getCsaleid());//销售订单id
                    deleteU8cDataUtilDao.updateCdeptid(updateSoSaleCdeptId);
                }
            }

            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
            if (deleteU8cDataUtilEntities2 != null && deleteU8cDataUtilEntities2.size() > 0) {
                //还存在部门字段错误的数据行，重新执行修复，确保目标数据被完全修复！
                repairSoSaleDepartment();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 销售订单审核
     */
    public void salesOrderReviewV2() {
        try {
            //确定销售订单范围、19648
            //注意⚠️这里只能审核已经修复完毕的销售订单！并且处理自由状态
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V3();
            if (deleteU8cDataUtilEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 100);
                for (int i = 0; i < lists.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));
                    //销售订单审批
                    DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
                    deleteSoSaleVo.setDataSourceCode("lets_u8c");
                    deleteSoSaleVo.setCsaleids(concatenatedIds);
                    deleteSoSaleVo.setFstatus("1");//自由状态
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = deleteU8cDataUtilDao.querySoSaleByDeletev2(deleteSoSaleVo);
                    Map<String, List<DeleteU8cDataUtilEntity>> deleteU8cDataUtilEntitiesMap = groupByDbilldatev2(deleteU8cDataUtilEntities2);
                    if (deleteU8cDataUtilEntitiesMap.size() > 0) {
                        for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : deleteU8cDataUtilEntitiesMap.entrySet()) {
                            String key = entry.getKey();
                            List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                            List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                            String[] split = key.split("@@@@");

                            //批量销售订单审批
                            JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();

                            QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
                            queryinfoCancelSignature.setDate_begin(split[0]);
                            queryinfoCancelSignature.setDate_end(split[0]);
                            queryinfoCancelSignature.setCorp(split[1]);
                            queryinfoCancelSignature.setCode(vreceiptcodeList);

                            ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
                            approveinfoCancelSignature.setApprovid("tbadmin");

                            jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
                            jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/approve", JSON.toJSONString(jsonRootBeanCancelSignature), vreceiptcodeList.size());
                        }
                    }
                }
            }

            //再次确认是否存在已经修复完毕，但未审核的销售订单
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities22All = new ArrayList<>();
            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V3();
            if (deleteU8cDataUtilEntities2 != null && deleteU8cDataUtilEntities2.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities2, 999);
                for (int i = 0; i < lists.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));

                    if (concatenatedIds == null || "".equals(concatenatedIds.trim())) {
                        throw new Exception("concatenatedIds == null || \"\".equals(concatenatedIds)");
                    }
                    DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
                    deleteSoSaleVo.setDataSourceCode("lets_u8c");
                    deleteSoSaleVo.setCsaleids(concatenatedIds);
                    deleteSoSaleVo.setFstatus("1");
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities22 = deleteU8cDataUtilDao.querySoSaleByDeletev2(deleteSoSaleVo);
                    deleteU8cDataUtilEntities22All.addAll(deleteU8cDataUtilEntities22);
                }
            }
            if (deleteU8cDataUtilEntities22All.size() > 0) {
                Thread.sleep(10000);
                salesOrderReviewV2();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 弃审+删除应收单
     *
     * @author liuyang
     */
//    public void unApprovalDeleteAccountsReceivable() {
//        try {
//            //确定销售订单范围、19648
//            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
//            if (deleteU8cDataUtilEntities.size() > 0) {
//                List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities, 500);
//                for (int i = 0; i < lists.size(); i++) {
//                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
//                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));
//                    //查询需要弃审的应收单
//                    Map<String, List<Map<String, String>>> mapList = new HashMap();
//                    List<Map<String, String>> mapList1 = new ArrayList<>();
//
//                    DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
//                    deleteSoSaleVo.setCsaleid(concatenatedIds);
//                    deleteSoSaleVo.setSpzt("1");
//                    List<ArapDjzbVo> arapDjzbVos = deleteU8cDataUtilDao.abandonmentAccountsReceivableDocV2(deleteSoSaleVo);
//                    if (arapDjzbVos != null && arapDjzbVos.size() > 0) {
//                        for (int j = 0; j < arapDjzbVos.size(); j++) {
//                            ArapDjzbVo arapDjzbVo = arapDjzbVos.get(j);
//
//                            Map<String, String> stringStringMap = new HashMap<>();
//                            stringStringMap.put("djbh", arapDjzbVo.getDjbh());//单据编码
//                            stringStringMap.put("dwbm", arapDjzbVo.getUnitcode());//公司编码
//                            stringStringMap.put("operatedate", arapDjzbVo.getDjrq());//单据日期
//                            stringStringMap.put("operatorid", "18846145294");//操作人编码
//                            mapList1.add(stringStringMap);
//                        }
//                    }
//
//                    if (mapList1.size() > 0) {
//                        mapList.put("bills", mapList1);
////                        sendU8C("http://39.170.109.90:8088/u8cloud/api/arap/ys/unaudit", JSON.toJSONString(mapList), mapList1.size());
//                    }
//
//                    //删除应收单
//                    DeleteSoSaleVo deleteSoSaleVo2 = new DeleteSoSaleVo();
//                    deleteSoSaleVo2.setCsaleid(concatenatedIds);
////                    deleteSoSaleVo2.setSpzt("1");
//                    deleteSoSaleVo2.setSpztnull("1");//a.spzt is null
//                    List<ArapDjzbVo> arapDjzbVos2 = deleteU8cDataUtilDao.abandonmentAccountsReceivableDocV2(deleteSoSaleVo2);
//                    for (int j = 0; j < arapDjzbVos2.size(); j++) {
//                        ArapDjzbVo arapDjzbVo = arapDjzbVos2.get(j);
//
//                        Map<String, String> stringStringMap = new HashMap<>();
//                        stringStringMap.put("coperator", "tbadmin");
//
//                        Map<String, String> stringStringMap2 = new HashMap<>();
//                        stringStringMap2.put("dwbm", arapDjzbVo.getUnitcode());
//                        stringStringMap2.put("djbh_from", arapDjzbVo.getDjbh());
//                        stringStringMap2.put("djbh_to", arapDjzbVo.getDjbh());
//
//                        Map<String, Map<String, String>> stringStringMap3 = new HashMap<>();
//                        stringStringMap3.put("deleteinfo", stringStringMap);
//                        stringStringMap3.put("queryinfo", stringStringMap2);
////                        sendU8C("http://39.170.109.90:8088/u8cloud/api/arap/ys/delete", JSON.toJSONString(stringStringMap3), 1);
//                    }
//                }
//            }
//
//            //判断是否存在失败的应收单
//            List<ArapDjzbVo> arapDjzbVosAll = new ArrayList<>();
//            List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities2 = deleteU8cDataUtilDao.cancelSignatureSoSaleReadExcel20250528V2();
//            if (deleteU8cDataUtilEntities2.size() > 0) {
//                List<List<DeleteU8cDataUtilEntity>> lists = SplitListByCountUtil.splitListByCount(deleteU8cDataUtilEntities2, 999);
//                for (int i = 0; i < lists.size(); i++) {
//                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities1 = lists.get(i);
//                    String concatenatedIds = deleteU8cDataUtilEntities1.stream().map(DeleteU8cDataUtilEntity::getCsaleid).map(csaleid -> "'" + csaleid + "'").collect(Collectors.joining(","));
//
//                    DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
//                    deleteSoSaleVo.setCsaleid(concatenatedIds);
//                    deleteSoSaleVo.setSpzt("0,1,2,null");
//                    List<ArapDjzbVo> arapDjzbVos = deleteU8cDataUtilDao.abandonmentAccountsReceivableDocV2(deleteSoSaleVo);
//                    arapDjzbVosAll.addAll(arapDjzbVos);
//                }
//            }
//            if (arapDjzbVosAll.size() > 0) {
//                unApprovalDeleteAccountsReceivable();
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

    /**
     * 汇总相同时间+公司的单据
     *
     * @author liuyang
     */
//    private void repairSoSaleDepartment(List<ArapDjzbVo> arapDjzbVos) {
//        Map<String, List<ArapDjzbVo>> resultMap = new HashMap<>();
//        for (ArapDjzbVo entity : arapDjzbVos) {
//            String dbilldate = entity.getDbilldate();
//            String unitcode = entity.getUnitcode();
//            // 如果 map 中不包含该日期，则创建一个新的列表
//            resultMap.computeIfAbsent(dbilldate + "@@@@" + unitcode, k -> new ArrayList<>()).add(entity);
//        }
//        return resultMap;
//    }
}